diff --git a/module/zfs/dmu_send.c b/module/zfs/dmu_send.c
index 359ef99d35f..f7d917949b2 100644
--- a/module/zfs/dmu_send.c
+++ b/module/zfs/dmu_send.c
@@ -2482,11 +2482,15 @@ receive_object(struct receive_writer_arg *rwa, struct drr_object *drro,
 	} else if (drro->drr_type != doi.doi_type ||
 	    drro->drr_blksz != doi.doi_data_block_size ||
 	    drro->drr_bonustype != doi.doi_bonus_type ||
-	    drro->drr_bonuslen != doi.doi_bonus_size) {
+	    drro->drr_bonuslen != doi.doi_bonus_size ||
+	    (!(drro->drr_dn_slots == 0 &&
+	    doi.doi_dnodesize == DNODE_MIN_SIZE) &&
+	    drro->drr_dn_slots != (doi.doi_dnodesize >> DNODE_SHIFT))) {
 		/* currently allocated, but with different properties */
-		err = dmu_object_reclaim(rwa->os, drro->drr_object,
+		err = dmu_object_reclaim_dnsize(rwa->os, drro->drr_object,
 		    drro->drr_type, drro->drr_blksz,
-		    drro->drr_bonustype, drro->drr_bonuslen, tx);
+		    drro->drr_bonustype, drro->drr_bonuslen,
+		    drro->drr_dn_slots << DNODE_SHIFT, tx);
 	}
 	if (err != 0) {
 		dmu_tx_commit(tx);
diff --git a/tests/runfiles/linux.run b/tests/runfiles/linux.run
index 0cbbfa03e52..422e0a773d3 100644
--- a/tests/runfiles/linux.run
+++ b/tests/runfiles/linux.run
@@ -520,7 +520,7 @@ tests = ['rsend_001_pos', 'rsend_002_pos', 'rsend_003_pos', 'rsend_004_pos',
     'send-c_lz4_disabled', 'send-c_recv_lz4_disabled',
     'send-c_mixed_compression', 'send-c_stream_size_estimate', 'send-cD',
     'send-c_embedded_blocks', 'send-c_resume', 'send-cpL_varied_recsize',
-    'send-c_recv_dedup', 'send_encrypted_heirarchy']
+    'send-c_recv_dedup', 'send_encrypted_heirarchy', 'send_changed_dnodesize']
 
 [tests/functional/scrub_mirror]
 tests = ['scrub_mirror_001_pos', 'scrub_mirror_002_pos',
diff --git a/tests/zfs-tests/tests/functional/rsend/Makefile.am b/tests/zfs-tests/tests/functional/rsend/Makefile.am
index 199acb68bb6..7d5d1f027d5 100644
--- a/tests/zfs-tests/tests/functional/rsend/Makefile.am
+++ b/tests/zfs-tests/tests/functional/rsend/Makefile.am
@@ -23,6 +23,7 @@ dist_pkgdata_SCRIPTS = \
 	rsend_021_pos.ksh \
 	rsend_022_pos.ksh \
 	rsend_024_pos.ksh \
+	send_changed_dnodesize.ksh \
 	send_encrypted_heirarchy.ksh \
 	send-cD.ksh \
 	send-c_embedded_blocks.ksh \
diff --git a/tests/zfs-tests/tests/functional/rsend/send_changed_dnodesize.ksh b/tests/zfs-tests/tests/functional/rsend/send_changed_dnodesize.ksh
new file mode 100755
index 00000000000..dfece7132a8
--- /dev/null
+++ b/tests/zfs-tests/tests/functional/rsend/send_changed_dnodesize.ksh
@@ -0,0 +1,73 @@
+#!/bin/ksh
+
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright (c) 2017 by Lawrence Livermore National Security, LLC.
+#
+
+. $STF_SUITE/include/libtest.shlib
+. $STF_SUITE/tests/functional/rsend/rsend.kshlib
+
+#
+# Description:
+# Verify incremental receive properly handles objects with changed
+# dnode size.
+#
+# Strategy:
+# 1. Populate a dataset with dnodesize=auto with objects
+# 2. Take a snapshot
+# 3. Remove objects and set dnodesize=legacy
+# 4. Remount dataset so object numbers get recycled and formerly
+#    "interior" dnode slots get assigned to new objects
+# 5. Repopulate dataset
+# 6. Send first snapshot to new dataset
+# 7. Send incremental snapshot from second snapshot to new dataset
+#
+
+verify_runnable "both"
+
+log_assert "Verify incremental receive handles objects with changed dnode size"
+
+function cleanup
+{
+	if datasetexists dnpool ; then
+		log_must_busy zpool destroy -f dnpool
+	fi
+	rm -f $TESTDIR/dnpool
+	rm -f $BACKDIR/fs-dn-auto
+	rm -f $BACKDIR/fs-dn-legacy
+}
+
+log_onexit cleanup
+
+log_must mkfile $SPA_MINDEVSIZE  $TESTDIR/dnpool
+log_must zpool create dnpool $TESTDIR/dnpool
+log_must zfs create -o dnodesize=auto dnpool/fs
+mk_files 200 262144 0 dnpool/fs
+log_must zfs unmount dnpool/fs
+log_must zfs snapshot dnpool/fs@a
+log_must zfs mount dnpool/fs
+log_must rm /dnpool/fs/*
+log_must zfs unmount dnpool/fs
+log_must zfs set dnodesize=legacy dnpool/fs
+log_must zfs mount dnpool/fs
+mk_files 200 262144 0 dnpool/fs
+log_must zfs unmount dnpool/fs
+log_must zfs snapshot dnpool/fs@b
+log_must eval "zfs send dnpool/fs@a > $BACKDIR/fs-dn-auto"
+log_must eval "zfs send -i dnpool/fs@a dnpool/fs@b > $BACKDIR/fs-dn-legacy"
+log_must eval "zfs recv dnpool/newfs < $BACKDIR/fs-dn-auto"
+log_must eval "zfs recv dnpool/newfs < $BACKDIR/fs-dn-legacy"
+
+
+log_pass "Verify incremental receive handles objects with changed dnode size"
